/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package hk.quantr.netbeans.riscv.window;

import hk.quantr.javalib.CommonLib;
import java.awt.image.BufferedImage;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
        dtd = "-//hk.quantr.netbeans.riscv.window//Instruction//EN",
        autostore = false
)
@TopComponent.Description(
        preferredID = "InstructionTopComponent",
        iconBase = "hk/quantr/netbeans/riscv/window/instruction.png",
        persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "output", openAtStartup = false)
@ActionID(category = "Window", id = "hk.quantr.netbeans.riscv.window.InstructionTopComponent")
@ActionReference(path = "Menu/Window/RISCV" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
        displayName = "#CTL_InstructionAction",
        preferredID = "InstructionTopComponent"
)
@Messages({
    "CTL_InstructionAction=Instruction",
    "CTL_InstructionTopComponent=Instruction Window",
    "HINT_InstructionTopComponent=This is a Instruction window"
})
public final class InstructionTopComponent extends TopComponent {

    public InstructionTopComponent() {
        initComponents();
        setName(Bundle.CTL_InstructionTopComponent());
        setToolTipText(Bundle.HINT_InstructionTopComponent());

    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
     * Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        instructionTabbedPane = new javax.swing.JTabbedPane();
        instruction = new javax.swing.JPanel();
        instuctionToolBar = new javax.swing.JToolBar();
        instructionComboBox = new javax.swing.JComboBox<>();
        instructionDisasm = new javax.swing.JButton();
        instructionCseip = new javax.swing.JButton();
        instructionUp = new javax.swing.JButton();
        instructionDown = new javax.swing.JButton();
        instructionGreenIcon = new javax.swing.JButton();
        instructionSave = new javax.swing.JButton();
        instructionScrollPane = new javax.swing.JScrollPane();
        instructionTable = new javax.swing.JTable();
        breakpoint = new javax.swing.JPanel();

        setLayout(new java.awt.BorderLayout());

        instruction.setLayout(new java.awt.BorderLayout());

        instuctionToolBar.setRollover(true);

        instructionComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        instructionComboBox.setMaximumSize(new java.awt.Dimension(100, 1000));
        instuctionToolBar.add(instructionComboBox);

        org.openide.awt.Mnemonics.setLocalizedText(instructionDisasm, org.openide.util.NbBundle.getMessage(InstructionTopComponent.class, "InstructionTopComponent.instructionDisasm.text")); // NOI18N
        instructionDisasm.setFocusable(false);
        instructionDisasm.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionDisasm.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionDisasm);

        org.openide.awt.Mnemonics.setLocalizedText(instructionCseip, org.openide.util.NbBundle.getMessage(InstructionTopComponent.class, "InstructionTopComponent.instructionCseip.text")); // NOI18N
        instructionCseip.setFocusable(false);
        instructionCseip.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionCseip.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionCseip);

        instructionUp.setIcon(CommonLib.resizeImageToIcon(new javax.swing.ImageIcon("/home/abc/pic.uparrow.png"), 13, 13, BufferedImage.TYPE_4BYTE_ABGR));
        instructionUp.setFocusable(false);
        instructionUp.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionUp.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionUp);

        instructionDown.setIcon(CommonLib.resizeImageToIcon(new javax.swing.ImageIcon("/home/abc/pic.downarrow.png"), 13, 13, BufferedImage.TYPE_4BYTE_ABGR));
        instructionDown.setFocusable(false);
        instructionDown.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionDown.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionDown);

        instructionGreenIcon.setIcon(CommonLib.resizeImageToIcon(new javax.swing.ImageIcon("/home/abc/pic.green.png"), 13, 13, BufferedImage.TYPE_4BYTE_ABGR));
        instructionGreenIcon.setToolTipText(org.openide.util.NbBundle.getMessage(InstructionTopComponent.class, "InstructionTopComponent.instructionGreenIcon.toolTipText")); // NOI18N
        instructionGreenIcon.setFocusable(false);
        instructionGreenIcon.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionGreenIcon.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionGreenIcon);

        instructionSave.setIcon(CommonLib.resizeImageToIcon(new javax.swing.ImageIcon("/home/abc/pic.save.png"), 15, 15, BufferedImage.TYPE_4BYTE_ABGR));
        instructionSave.setFocusable(false);
        instructionSave.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instructionSave.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        instuctionToolBar.add(instructionSave);

        instruction.add(instuctionToolBar, java.awt.BorderLayout.PAGE_START);

        instructionTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Address", "Instruction", "Bytes"
            }
        ));
        instructionScrollPane.setViewportView(instructionTable);

        instruction.add(instructionScrollPane, java.awt.BorderLayout.CENTER);

        instructionTabbedPane.addTab("Instruction", instruction);

        breakpoint.setLayout(new java.awt.BorderLayout());
        instructionTabbedPane.addTab("Breakpoint", breakpoint);

        add(instructionTabbedPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel breakpoint;
    private javax.swing.JPanel instruction;
    private javax.swing.JComboBox<String> instructionComboBox;
    private javax.swing.JButton instructionCseip;
    private javax.swing.JButton instructionDisasm;
    private javax.swing.JButton instructionDown;
    private javax.swing.JButton instructionGreenIcon;
    private javax.swing.JButton instructionSave;
    private javax.swing.JScrollPane instructionScrollPane;
    private javax.swing.JTabbedPane instructionTabbedPane;
    private javax.swing.JTable instructionTable;
    private javax.swing.JButton instructionUp;
    private javax.swing.JToolBar instuctionToolBar;
    // End of variables declaration//GEN-END:variables
    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    void readProperties(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }
}
